#include <iostream>
#include <Imagine/Images.h>
#include <queue>

using namespace std;
using namespace Imagine;

int main() {
	// Byte image
	Image<byte> Ib;
	load(Ib,srcPath("tools.jpg"));
	int w=Ib.width(),h=Ib.height();
	openWindow(w,h);
	display(Ib);
	click();


	// Double image, smoothed
	Image<double> I(Ib);
	I=blur(I,2.);
	display(grey(I));click();

	// Gradient and norm
	Image<double> Ix(w,h);
	Image<double> Iy(w,h);
	Image<double> NG(w,h);
	for (int j=0;j<h;j++) {
		for (int i=0;i<w;i++) {
			// 1) Remplacer par Sobel
			double ix=0,iy=0;
			Ix(i,j)=ix; Iy(i,j)=iy;
			NG(i,j)=sqrt(ix*ix+iy*iy);
		}
	}
	display(grey(Ix));click();
	display(grey(Iy));click();
	display(grey(NG));click();

	// Thresholding
	Image<byte> C(w,h);
	for (int j=0;j<h;j++)
		for (int i=0;i<w;i++)
			// 2) Remplacer par un seuillage simple
			C(i,j)=0;
	display(C);click();

	// 3) calculer et afficher le resulat d'un NMS
	// 4) calculer et afficher le resulat d'un seuillage par hysteresis
	endGraphics();
	return 0;
}
